﻿<#
	Upgrades ls admin features to ensure that the upgrade event receiver is called.
#>
function Upgrade-Features($parameters, [System.Xml.XmlElement]$data, [string]$extId, [string]$extensionPath) {
    Log -message ("Extension ID: "+ $extId) -type $SPSD.LogTypes.Normal
    Log -message ("Extension path: "+ $extensionPath) -type $SPSD.LogTypes.Normal
	
	# Feature id for Jobs feature
	$featureIdString = "81af461f-65c3-4e1f-af72-731324090571"
	
	$execPath = $extensionPath.SubString(0, $extensionPath.LastIndexOf("\"))
	$scriptPath = $execPath.SubString(0, $execPath.LastIndexOf("\")) + "\UpgradeFeatures.ps1"

	# Launch a new powershell to ensure that the newest assembly version is loaded
	Log -message ("Calling script: "+ $scriptPath) -type $SPSD.LogTypes.Normal

	$argumentList = "-Version $($PSVersionTable.PSVersion.Major) ""$scriptPath -param_FeatureIdString $featureIdString -DEBUG:`$false"""
	$ps = Start-Process "$PSHOME\powershell.exe" -Verb RunAs -ArgumentList "$argumentList" -PassThru
	$ps.WaitForExit()
}